/**
 * UFRST Le Havre - TD/TP l2
 * 
 * Exemple de tri/fusion rcursif utilisant des threads
 *  
 */

import java.util.Random;

class Tableau {
    private static final int DODO = 0;

    private int tableau[];

    Tableau(int taille) {
        tableau = new int[taille];
    }

    Tableau(int taille, int borne) {
        this(taille);
        Random generateur = new Random();
        for (int i = 0; i < tableau.length; i++)
            tableau[i] = generateur.nextInt(borne);
    }

    synchronized int getElement(int i) {
        return tableau[i];
    }

    synchronized void setElement(int indice, int valeur) {
        tableau[indice] = valeur;
    }

    synchronized void afficheTableau() {
        for (int i = 0; i < tableau.length; i++) {
            System.out.print(tableau[i] + " ");
            try {
                Thread.sleep(DODO);
            } catch (InterruptedException e) {
            }
        }
        System.out.println("");
    }

    int getTaille() {
        return tableau.length;
    }

    Tableau copieTableau(int debut, int fin) {
        Tableau copie = new Tableau(fin - debut);
        System.arraycopy(tableau, debut, copie.tableau, 0, fin - debut);
        return copie;
    }
}

class Tri implements Runnable {
    Tableau tab;

    Tri(Tableau t) {
        tab = t;
    }

    void fusionne(Tableau haut, Tableau bas) {
        int indiceHaut = 0, indiceBas = 0, indiceTab = 0;
        while (indiceHaut < haut.getTaille() && indiceBas < bas.getTaille()) {
            if (bas.getElement(indiceBas) < haut.getElement(indiceHaut)) {
                tab.setElement(indiceTab, bas.getElement(indiceBas));
                indiceBas++;
            } else {
                tab.setElement(indiceTab, haut.getElement(indiceHaut));
                indiceHaut++;
            }
            indiceTab++;
        }
        for (; indiceBas < bas.getTaille(); indiceBas++) {
            tab.setElement(indiceTab, bas.getElement(indiceBas));
            indiceTab++;
        }
        for (; indiceHaut < haut.getTaille(); indiceHaut++) {
            tab.setElement(indiceTab, haut.getElement(indiceHaut));
            indiceTab++;
        }
        tab.afficheTableau();
    }

    void fusionneRecursif(Tableau bas, int indiceBas, Tableau haut,
            int indiceHaut, int indiceTab) {
        boolean finiDansBas = indiceBas >= bas.getTaille();
        boolean finiDansHaut = indiceHaut >= haut.getTaille();

        if (!finiDansBas
                && (finiDansHaut || bas.getElement(indiceBas) < haut
                        .getElement(indiceHaut))) {
            tab.setElement(indiceTab, bas.getElement(indiceBas));
            fusionneRecursif(bas, indiceBas + 1, haut, indiceHaut,
                    indiceTab + 1);
        } else if (!finiDansHaut
                && (finiDansBas || bas.getElement(indiceBas) >= haut
                        .getElement(indiceHaut))) {
            tab.setElement(indiceTab, haut.getElement(indiceHaut));
            fusionneRecursif(bas, indiceBas, haut, indiceHaut + 1,
                    indiceTab + 1);
        } else
            tab.afficheTableau();
    }

    public void run() {
        if (tab.getTaille() > 1) {
            Tableau bas = tab.copieTableau(0, tab.getTaille() / 2);
            Tableau haut = tab.copieTableau(tab.getTaille() / 2, tab
                    .getTaille());
            Thread filsBas = new Thread(new Tri(bas));
            Thread filsHaut = new Thread(new Tri(haut));
            filsBas.start();
            filsHaut.start();
            try {
                filsBas.join();
                filsHaut.join();
            } catch (InterruptedException e) {
            }
            //fusionne(bas, haut);
            fusionneRecursif(bas, 0, haut, 0, 0);
        }
    }
}

public class TriFusion {

    public static void main(String[] args) {
        System.out.println("java TriFusion <nombre d'lments> <valeur max>");
        Tableau t = new Tableau(Integer.parseInt(args[0]), Integer
                .parseInt(args[1]));
        t.afficheTableau();
        System.out.println("-----------------------------------------");
        Thread papa = new Thread(new Tri(t));
        papa.start();
        try {
            papa.join();
        } catch (InterruptedException e) {
        }
    }
}